#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "../src/file.h"

#include "installDialog.h"
#include "../src/pics/logo.xpm"

installDialog::installDialog(QWidget *parent, char *name) 
	: QDialog(parent,name,TRUE,WStyle_Customize | WStyle_NormalBorder)
{
	setCaption("ICQnix Installation");
	setFixedSize(372, 228);
	setStyle(WindowsStyle);
	//setIcon(QPixmap(icon_xpm));

	currentPanel = 0;

	lblLogo = new QLabel(this, "lblLogo");
	lblLogo->setGeometry(5, 5, 100, 160);
	lblLogo->setPixmap(QPixmap(logo_xpm));

	lblVersion = new QLabel(this, "lblVersion");
	lblVersion->setGeometry(10, 170, 100, 15);
	lblVersion->setText("v. Beta 1");

// PANEL #1
	panel1 = new QFrame(this);
	panel1->setGeometry( 110, 0, width()-115, height() - 50 );
   
	lblTitle1 = new QLabel(panel1, "lblTitle1");
	lblTitle1->setText("ICQnix Installation");
	lblTitle1->setFont(QFont("times",18,QFont::Bold,(int)1));
	lblTitle1->setAlignment(AlignLeft | AlignTop);
	lblTitle1->setGeometry(50,8,175,27);
	lblTitle1->setPalette(QPalette(
	  QColorGroup(QColor(0,0,0), QColor(192,192,192),
	  QColor(255,255,255),QColor(96,96,96),QColor(160,160,160),
	  QColor(0,0,255),QColor(255,255,255)),
	  QColorGroup(QColor(128,128,128), QColor(192,192,192),
	  QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
	  QColor(128,128,128),QColor(192,192,192)),
	  QColorGroup(QColor(0,0,0), QColor(192,192,192),
	  QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
	  QColor(0,0,0),QColor(255,255,255))));
	
	lblDescription1 = new QLabel(panel1, "lblDescription1");
	lblDescription1->setText("Welcome to the ICQnix installation\nprogram. This program will attempt to\npainlessly setup the necessary\nconfiguration files for ICQnix.\n\nClick Next to continue or\nCancel to quit.");
	lblDescription1->setAlignment(AlignLeft | AlignTop);
	lblDescription1->setGeometry(5,43,226,125);
	lblDescription1->setStyle(WindowsStyle);


// PANEL #2
	panel2 = new QFrame(this);
	panel2->hide();
	panel2->setGeometry( 110, 0, width() -115, height() - 50 );

  	lblTitle2 = new QLabel(panel2, "lblTitle2");
	lblTitle2->setText("ICQ # and Password");
	lblTitle2->setFont(QFont("times",18,QFont::Bold,(int)1));
	lblTitle2->setAlignment(AlignLeft | AlignTop);
	lblTitle2->setGeometry(45,8,175,27);
	lblTitle2->setPalette(QPalette(
	  QColorGroup(QColor(0,0,0), QColor(192,192,192),
	  QColor(255,255,255),QColor(96,96,96),QColor(160,160,160),
	  QColor(0,0,255),QColor(255,255,255)),
	  QColorGroup(QColor(128,128,128), QColor(192,192,192),
	  QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
	  QColor(128,128,128),QColor(192,192,192)),
	  QColorGroup(QColor(0,0,0), QColor(192,192,192),
	  QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
	  QColor(0,0,0),QColor(255,255,255))));
	
	lblDescription2 = new QLabel(panel2, "lblDescription2");
	lblDescription2->setText("Enter your existing ICQ number\nand password below:");
	lblDescription2->setAlignment(AlignLeft | AlignTop);
	lblDescription2->setGeometry(5,43,226,30);
	lblDescription2->setStyle(WindowsStyle);



	lblNickname = new QLabel(panel2, "lblNickname");
	lblNickname->setText("Nickname");
	lblNickname->setGeometry(25, 93, 50, 15); 

	edtNickname = new QLineEdit(panel2, "edtNickname");
	edtNickname->setGeometry(80, 90, 90, 20);
	
	lblICQNumber = new QLabel(panel2, "lblICQNumber");
	lblICQNumber->setText("ICQ #");
	lblICQNumber->setGeometry(25, 118, 30, 15); 

	edtICQNumber = new QLineEdit(panel2, "edtICQNumber");
	edtICQNumber->setGeometry(80, 115, 90, 20);

	lblPassword = new QLabel(panel2, "lblPassword");
	lblPassword->setText("Password");
	lblPassword->setGeometry(25, 146, 50, 15); 

	edtPassword = new QLineEdit(panel2, "edtPassword");
	edtPassword->setGeometry(80, 143, 90, 20);
	edtPassword->setEchoMode(QLineEdit::Password);

	

// PANEL #3	
	panel3 = new QFrame(this);
	panel3->hide();
	panel3->setGeometry( 110, 0, width()-115, height() - 50 );
	
  	lblTitle3 = new QLabel(panel3, "lblTitle3");
	lblTitle3->setText("Sound Configuration");
	lblTitle3->setFont(QFont("times",18,QFont::Bold,(int)1));
	lblTitle3->setAlignment(AlignLeft | AlignTop);
	lblTitle3->setGeometry(45,8,175,27);
	lblTitle3->setPalette(QPalette(
	  QColorGroup(QColor(0,0,0), QColor(192,192,192),
	  QColor(255,255,255),QColor(96,96,96),QColor(160,160,160),
	  QColor(0,0,255),QColor(255,255,255)),
	  QColorGroup(QColor(128,128,128), QColor(192,192,192),
	  QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
	  QColor(128,128,128),QColor(192,192,192)),
	  QColorGroup(QColor(0,0,0), QColor(192,192,192),
	  QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
	  QColor(0,0,0),QColor(255,255,255))));
	
	lblDescription3 = new QLabel(panel3, "lblDescription3");
	lblDescription3->setText("Here you need to specify a program\nto play sounds for ICQ events.\nesdplay is recommended.\n\n*warning* -- play has been known to\ncause random core dumps");
	lblDescription3->setAlignment(AlignLeft | AlignTop);
	lblDescription3->setGeometry(5,43,226,125);
	lblDescription3->setStyle(WindowsStyle);

	edtSound = new QLineEdit(panel3, "edtSound");
	edtSound->setText("esdplay");
	edtSound->setGeometry(5, 130, 90, 20);


// FINAL PANEL 
	finishedPanel = new QFrame(this);
	finishedPanel->hide();
	finishedPanel->setGeometry( 110, 0, width()-115, height() - 50 );
	//finishedPanel->setFrameStyle( QFrame::Panel | QFrame::Sunken );

	lblTitleFinished = new QLabel(finishedPanel, "lblTitleFinished");
	lblTitleFinished->setText("Installation Complete");
	lblTitleFinished->setFont(QFont("times",18,QFont::Bold,(int)1));
	lblTitleFinished->setAlignment(AlignLeft | AlignTop);
	lblTitleFinished->setGeometry(45,8,175,27);
	lblTitleFinished->setPalette(QPalette(
	  QColorGroup(QColor(0,0,0), QColor(192,192,192),
	  QColor(255,255,255),QColor(96,96,96),QColor(160,160,160),
	  QColor(0,0,255),QColor(255,255,255)),
	  QColorGroup(QColor(128,128,128), QColor(192,192,192),
	  QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
	  QColor(128,128,128),QColor(192,192,192)),
	  QColorGroup(QColor(0,0,0), QColor(192,192,192),
	  QColor(255,255,255), QColor(128,128,128), QColor(160,160,164),
	  QColor(0,0,0),QColor(255,255,255))));
	
	lblDescriptionFinished = new QLabel(finishedPanel, "lblDescriptionFinished");
	lblDescriptionFinished->setText("Click Finish to finalize your settings.\n\nTo run ICQnix, type:\n\n\t\ticqnix\n\nin an xterm.\n\n");
	lblDescriptionFinished->setAlignment(AlignLeft | AlignTop);
	lblDescriptionFinished->setGeometry(5,43,230,125);
	lblDescriptionFinished->setStyle(WindowsStyle);



	btnAbout = new QPushButton(this, "btnAbout");
	btnAbout->setText("About");
	btnAbout->setFont(QFont("helvetica",11,QFont::Normal,(int)0));
    	btnAbout->setGeometry(5,199,39,24);
	btnAbout->setStyle(WindowsStyle);

	btnCancel = new QPushButton(this, "btnCancel");
	btnCancel->setText("&Cancel");
	btnCancel->setGeometry(108,199,78,24);
	btnCancel->setStyle(WindowsStyle);
	
	btnBack = new QPushButton(this, "btnBack");
	btnBack->setText("<< &Back");
	btnBack->setFont(QFont("helvetica",11,QFont::Normal,(int)0));
	btnBack->setGeometry(198,199,79,24);
	btnBack->setStyle(WindowsStyle);
	btnBack->setEnabled(false);

	btnNext = new QPushButton(this, "btnNext");
	btnNext->setText("&Next >>");
	btnNext->setFont(QFont("helvetica",11,QFont::Normal,(int)0));
	btnNext->setGeometry(277,199,79,24);
	btnNext->setStyle(WindowsStyle);
	btnNext->setDefault(true);

	connect( btnAbout, SIGNAL(clicked()), this, SLOT(clickAbout()) );
	connect( btnCancel, SIGNAL(clicked()), this, SLOT(clickCancel()) );
	connect( btnBack, SIGNAL(clicked()), this, SLOT(clickBack()) );
	connect( btnNext, SIGNAL(clicked()), this, SLOT(clickNext()) );
	connect( this, SIGNAL(panelChange()), this, SLOT(updateButtons()) );
}

void installDialog::clickAbout()
{

	QMessageBox::about( this, "About ICQnix Installation", "ICQnix beta 1\nby Jacob M. Ciango\n\nhttp://www.chesapeake.net/~jacob/icq/");
}

void installDialog::clickCancel()
{
	emit finished();
	hide();
//    	return false;
}

void installDialog::clickBack()
{
	currentPanel--;
	emit panelChange();
}

void installDialog::clickNext()
{
	if (currentPanel < MAX_PANELS) {
		currentPanel++;
		emit panelChange(); }
	else if (currentPanel == MAX_PANELS)
		saveConfig();
}

void installDialog::updateButtons()
{
	btnBack->setEnabled(true);
	btnNext->setEnabled(true);
	
	if (currentPanel <=0)
		btnBack->setEnabled(false);

	if (currentPanel >= MAX_PANELS) {
		btnNext->setText("&Finish");
		btnCancel->setEnabled(false); }

	else if (currentPanel < MAX_PANELS) {
		btnNext->setText("&Next >>");
		btnCancel->setEnabled(true); }

	switch( currentPanel) {
		case 0: {
			panel1->show();
			panel2->hide();
			break; }
		case 1: {
			panel1->hide();
			panel2->show();
			panel3->hide();
			edtNickname->setFocus();
			break; }
		case 2: {
			panel2->hide();
			panel3->show();
			finishedPanel->hide();
			edtSound->setFocus();
			break; }
		case MAX_PANELS: {
			panel3->hide();
			finishedPanel->show();
			break; }
		default: break;
	}
		
}

void installDialog::saveConfig()
{
/* this is what the user's icqnix configuration directory structure will look like:
-----------------------------------------

---> .icqnix
-------> history/
-------> sounds/
-------> users/
-------------> users.conf
-------> themes/
-------> icqnix.conf
-------> geometry.conf

----------------------------------------- */


    	char SOURCE_DIR[128], BASE_DIR[128], USER_DIR[128], HISTORY_DIR[128], SOUNDS_DIR[128], TRANSLATIONS_DIR[128];
	char *home;
    	char *source;

	if ((home = getenv("HOME")) == NULL)
	{
		QMessageBox::critical( this, "ICQnix Installation", "Cannot get HOME environment", QMessageBox::Ok, 0);
		return;
	}

	if ((source = getenv("ICQNIX_SOURCE_DIR")) == NULL)
		sprintf(SOURCE_DIR, "/usr/local/share/icqnix/");
	else
		sprintf(SOURCE_DIR, source);	

    	char buf[256];
//    	sprintf(buf, "%s%s", BASE_DIR, "geometry.conf");
		
    
	sprintf(BASE_DIR, "%s/%s/", home, ".icqnix");
	sprintf(USER_DIR, "%s/%s/", BASE_DIR, "users"); 
	sprintf(HISTORY_DIR, "%s/%s/", BASE_DIR, "history"); 
	sprintf(SOUNDS_DIR, "%s/%s/", BASE_DIR, "sounds"); 
	sprintf(TRANSLATIONS_DIR, "%s/%s/", BASE_DIR, "translations"); 


	if (access(BASE_DIR, F_OK) < 0) // BASE_DIR doesn't exist
	{
		sprintf( buf, "mkdir -m 700 %s", BASE_DIR );
		system ( buf );
    }

	// copy default base config file
	sprintf(buf, "cp %sicqnix.conf %s/%s", SOURCE_DIR, BASE_DIR, "icqnix.conf");
    	system ( buf );	

	// change file permissions
	sprintf(buf, "chmod 600 %s/*", BASE_DIR);
	system(buf);



	if (access(USER_DIR, F_OK) < 0) // USER_DIR doesn't exist
	{
		sprintf( buf, "mkdir -m 700 %s", USER_DIR );
		system ( buf );
    }

	sprintf(buf, "cp %s/users.conf %s/%s", SOURCE_DIR, USER_DIR, "users.conf");
    	system ( buf );	

	// change file permissions
	sprintf(buf, "chmod 600 %s/*", USER_DIR);
	system(buf);


	if (access(HISTORY_DIR, F_OK) < 0) // HISTORY_DIR doesn't exist
	{
		sprintf( buf, "mkdir -m 700 %s", HISTORY_DIR );
		system ( buf );
    }



	if (access(SOUNDS_DIR, F_OK) < 0) // SOUNDS_DIR doesn't exist
	{
		sprintf( buf, "mkdir -m 700 %s", SOUNDS_DIR );
		system ( buf );
    }

	sprintf(buf, "cp %s/sounds/* %s", SOURCE_DIR, SOUNDS_DIR );
    	system ( buf );	

	// change file permissions
	sprintf(buf, "chmod 600 %s/*", SOUNDS_DIR);
	system(buf);



	if (access(TRANSLATIONS_DIR, F_OK) < 0) // TRANSLATIONS_DIR doesn't exist
	{
		sprintf( buf, "mkdir -m 700 %s", TRANSLATIONS_DIR );
		system ( buf );
    }

	sprintf(buf, "cp %s/translations/* %s", SOURCE_DIR, TRANSLATIONS_DIR );
    	system ( buf );	

	// change file permissions
	sprintf(buf, "chmod 600 %s/*", TRANSLATIONS_DIR);
	system(buf);





	sprintf(buf, "%s/icqnix.conf", BASE_DIR);
	File icqnixConf(buf);

	icqnixConf.section("owner").key("Password").write((char *)edtPassword->text());
	icqnixConf.section("owner").key("Uin").write((char *)edtICQNumber->text());
	icqnixConf.section("owner").key("Alias").write((char *)edtNickname->text());
    	icqnixConf.section("sound").key("Player").write((char *)edtSound->text());

	
	emit finished();
	hide();
//	return true;
}




