#include <stdio.h>
#include <qpushbt.h>
#include <qlabel.h>
#include "awaymsgdlg.h"
#include "qpixmap.h"
//#include "licqgui.h"

//#include "pics/status_away.xpm"
//#include "pics/status_dnd.xpm"
//#include "pics/status_occupied.xpm"
//#include "pics/status_na.xpm"

AwayMsgDlg::AwayMsgDlg(ICQOwner *theOwner, QWidget *parent = 0, const char *name = 0) : QDialog(parent, name)
{
   char info[200];
//   char status[30];
   owner = theOwner;
//   server = theServer;
   setFixedSize( 300, 150 );


/*   switch (server->icqOwner.status())
   {
     case ICQ_STATUS_AWAY: sprintf(status, "%s", "away"); break;
     case ICQ_STATUS_NA: sprintf(status, "%s", "N/A"); break;
     case ICQ_STATUS_OCCUPIED: sprintf(status, "%s", "occupied"); break;
     case ICQ_STATUS_DND: sprintf(status, "%s", "DND"); break;
   }
*/

   sprintf(info, "This message will be displayed to users when you are\nmarked away. The message may be modified to your\npreference.");
   QLabel *lblInfo;   
   lblInfo = new QLabel( info, this );

   lblInfo->setFont( QFont( "Times", 12, QFont::Normal ) );
   lblInfo->setGeometry( 5, 0, width()-20, 50 );
   mleAwayMsg = new MLEditWrap(true, this);
   mleAwayMsg->setGeometry(5, lblInfo->y() + lblInfo->height() + 3, width()-10, 60);
   QPushButton *btnOk;
   btnOk = new QPushButton( "OK", this );
   btnOk->setGeometry(width() - 90, height() - btnOk->height() - 2, 80, 25 );
   connect( btnOk, SIGNAL(clicked()), SLOT(ok()) );
}


void AwayMsgDlg::show()
{
//   char title[50];
//   char temp[10];

/*   switch (server->icqOwner.status())
   {
     case ICQ_STATUS_AWAY: sprintf(temp, "%s", "Away"); setIcon( QPixmap(away_xpm) ); break;
     case ICQ_STATUS_NA: sprintf(temp, "%s", "N/A"); setIcon( QPixmap(na_xpm) ); break;
     case ICQ_STATUS_OCCUPIED: sprintf(temp, "%s", "Occupied"); setIcon( QPixmap(occupied_xpm) ); break;
     case ICQ_STATUS_DND: sprintf(temp, "%s", "DND"); setIcon( QPixmap(dnd_xpm) ); break;
   }
*/
//   sprintf( title, "Change / Confirm %s Message", temp );
   setCaption( "Change / Confirm Message" );
   mleAwayMsg->setText(owner->awayMessage());

   QDialog::show();
}


void AwayMsgDlg::ok()
{
   char msg[4096];
   sprintf(msg, "%s", (const char *)mleAwayMsg->text()); 
   owner->setAwayMessage(msg);
   accept();
}
