#ifndef connectButton_H
#define connectButton_H


#include <qwidget.h>
#include <qtimer.h>
#include <qpushbutton.h>
#include <qpixmap.h>
#include <qpopupmenu.h>

enum icqStatus {stOnline, stAway, stDND, stNA, stOccupied, stFFC, stInvisible, stOffline, stLogin}; 

class PopupButton : public QPushButton {
  Q_OBJECT
public:
  PopupButton( QWidget *parent=0, const char *name=0 );
  ~PopupButton();
  void setStatus(icqStatus);
public slots:
signals:
  void updateIcon(QPixmap);
protected:
  int timerid;
  int picnum;
  virtual void drawButtonLabel(QPainter *);
  virtual void timerEvent(QTimerEvent *);
  QString ltext;
  QPixmap lpixmap;
protected slots:
private:
private slots:
};
 

class ICQPopupMenu : public QPopupMenu {
  Q_OBJECT
public:
  ICQPopupMenu( QWidget *parent=0 );
  void hide();
signals:
  void hideMenu();
};


#endif
