#ifndef ICQNIX_H
#define ICQNIX_H

#include <qapp.h>

#include "icq.h"
#include "icqgui.h"

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef USE_KDE
#include "kicq.h"
class ICQnix : public KApplication
#else
class ICQnix : public QApplication
#endif

{
public:
   ICQnix(int argc, char **argv);
   ~ICQnix(void);
   bool quitNow(void);
protected:
   void usage(void);
   bool installBaseDir(void);
   bool quitNowVal;
   ICQ *icq;
   ICQnixGUI *icqgui;
#ifdef USE_KDE
   Kicq *kicq;
#endif

};

#endif
